<?php
namespace Bushelpowered\Api\Fulfillment\Recipient\V1\Response;
        
class RecipientDetailResponse implements Api\Common\HasCreatedAtTimestamp, Api\Common\HasUpdatedAtTimestamp
{
    public string $id;
    public string $name;
    public string $email;
    public string $phoneNumber;
    public bool $enableEmail;
    public bool $enablePhoneNumber;
    /** @var \Bushelpowered\Api\Fulfillment\Threshold\V1\Response\ThresholdResponse[] $thresholds */
    public array $thresholds;
    public int $createdAt;
    public int $updatedAt;

    /**
     * @param  null  $id
     * @param  null  $name
     * @param  null  $email
     * @param  null  $phoneNumber
     * @param  null  $enableEmail
     * @param  null  $enablePhoneNumber
     * @param  \Bushelpowered\Api\Fulfillment\Threshold\V1\Response\ThresholdResponse[]  $thresholds
     * @param  null  $createdAt
     * @param  null  $updatedAt
     */
    public function __construct(string $id, string $name, string $email, string $phoneNumber, bool $enableEmail, bool $enablePhoneNumber, array $thresholds, int $createdAt, int $updatedAt)
    {
        $this->id = $id;
        $this->name = $name;
        $this->email = $email;
        $this->phoneNumber = $phoneNumber;
        $this->enableEmail = $enableEmail;
        $this->enablePhoneNumber = $enablePhoneNumber;
        $this->thresholds = $thresholds;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
}