<?php
namespace Bushelpowered\Api\Iam\Access\Common\V1alpha;
        
class Role implements Api\Common\HasTimestamps
{
    public string $name;
    /** @var string[] $permissions */
    public array $permissions;
    public bool $isTenantDefined;
    public ?string $tenantId = null;
    public int $createdAt;
    public int $updatedAt;
    public ?int $deletedAt = null;

    /**
     * @param  null  $name
     * @param  string[]  $permissions
     * @param  null  $isTenantDefined
     * @param  null  $tenantId
     * @param  null  $createdAt
     * @param  null  $updatedAt
     * @param  null  $deletedAt
     */
    public function __construct(string $name, array $permissions, bool $isTenantDefined, ?string $tenantId, int $createdAt, int $updatedAt, ?int $deletedAt)
    {
        $this->name = $name;
        $this->permissions = $permissions;
        $this->isTenantDefined = $isTenantDefined;
        $this->tenantId = $tenantId;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
}