<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1alpha;

use \Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Request\LookupResourcesRequest;
use \Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Response\LookupResourcesResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bidl\Php\Core\Builtins\UnknownError;

class LookupResources 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(LookupResourcesRequest $request, $headers): LookupResourcesResponse | BadRequest | NotAuthenticated | UnknownError
    {
         return $this->client->call('api/iam/access/evaluate/v1alpha/LookupResources', $request, new LookupResourcesResponseWrapper(), $headers)->response;
    }
}

class LookupResourcesResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var LookupResourcesResponse | BadRequest | NotAuthenticated | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.iam.access.evaluate.v1alpha#LookupResourcesSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Response\LookupResourcesResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}