<?php
namespace Bushelpowered\Api\Iam\Access\Evaluate\V1alpha\Request;
        
class CheckEntityRequest implements Api\Iam\Access\Common\V1alpha\Mixins\HasConsistency, Api\Iam\Access\Common\V1alpha\Mixins\HasPermissions, Api\Iam\Access\Common\V1alpha\Mixins\HasEntity
{
    public \Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Consistency $consistency = null;
    /** @var string[] $permissions */
    public array $permissions;
    public \Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Entity $entity;

    /**
     * @param  null  $consistency
     * @param  string[]  $permissions
     * @param  null  $entity
     */
    public function __construct(\Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Consistency $consistency, array $permissions, \Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Entity $entity)
    {
        $this->consistency = $consistency;
        $this->permissions = $permissions;
        $this->entity = $entity;
    }
    
    public function getConsistency(): \Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Consistency
    {
        return $this->consistency;
    }
    /**
     * @return string[]
     */
    public function getPermissions(): array
    {
        return $this->permissions;
    }
    public function getEntity(): \Bushelpowered\Api\Iam\Access\Common\V1alpha\Mixins\Entity
    {
        return $this->entity;
    }
}