<?php
namespace Bushelpowered\Api\Iam\Access\Manage\V1alpha;

use \Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\CreateRelationshipsRequest;
use \Bushelpowered\Api\Iam\Access\Manage\V1alpha\Response\CreateRelationshipsResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class CreateRelationships 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    public function call(CreateRelationshipsRequest $request, $headers): CreateRelationshipsResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/iam/access/manage/v1alpha/CreateRelationships', $request, new CreateRelationshipsResponseWrapper(), $headers)->response;
    }
}

class CreateRelationshipsResponseWrapper implements \Bidl\Php\Core\BIDlResponse {

    /** @var CreateRelationshipsResponse | BadRequest | NotAuthenticated | NotAuthorized | UnknownError */
    public $response;

    public function __construct()
    {
        $this->mapper = new \JsonMapper();
    }
    
    public function fromJson($data) 
    {
        switch($data->type) {
          case 'api.iam.access.manage.v1alpha#CreateRelationshipsSuccess':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Response\CreateRelationshipsResponse::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#BadRequest':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthenticated':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
          case 'api.common#NotAuthorized':
            $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
            $this->response = $this->mapper->map($data, $empty);
            break;
           default: 
             $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
        }
    }
}