<?php

namespace Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request;

class Relationship
{
    public string $type;
    private $data;
    private \JsonMapper $mapper;

    private $types = [
        locationToTenant => '\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\LocationToTenantRelationship',
        locationToLocation => '\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\LocationToLocationRelationship',
        accountToTenant => '\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\AccountToTenantRelationship',
    ];

    private function __constructor($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function LocationToTenant(\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\LocationToTenantRelationship $data): Relationship
    {
        return Relationship(locationToTenant, $data);
    }
    public static function LocationToLocation(\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\LocationToLocationRelationship $data): Relationship
    {
        return Relationship(locationToLocation, $data);
    }
    public static function AccountToTenant(\Bushelpowered\Api\Iam\Access\Manage\V1alpha\Request\AccountToTenantRelationship $data): Relationship
    {
        return Relationship(accountToTenant, $data);
    }

    public function getData() {
        $className = $this->types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    