<?php
namespace Bushelpowered\Api\Platform\Branding\V1\Response;
        
class BrandResponse implements Api\Common\HasTimestamps
{
    public string $id;
    public string $flavorId;
    public string $colorPrimary;
    public string $colorSecondary;
    public ?string $launcherUrl = null;
    public ?string $iosAppIconUrl = null;
    public ?string $logoIdUrl = null;
    public ?string $logoStackedUrl = null;
    public ?string $iosSplashScreenUrl = null;
    public bool $hideBushelBranding;
    public int $createdAt;
    public int $updatedAt;
    public ?int $deletedAt = null;

    /**
     * @param  null  $id
     * @param  null  $flavorId
     * @param  null  $colorPrimary
     * @param  null  $colorSecondary
     * @param  null  $launcherUrl
     * @param  null  $iosAppIconUrl
     * @param  null  $logoIdUrl
     * @param  null  $logoStackedUrl
     * @param  null  $iosSplashScreenUrl
     * @param  null  $hideBushelBranding
     * @param  null  $createdAt
     * @param  null  $updatedAt
     * @param  null  $deletedAt
     */
    public function __construct(string $id, string $flavorId, string $colorPrimary, string $colorSecondary, ?string $launcherUrl, ?string $iosAppIconUrl, ?string $logoIdUrl, ?string $logoStackedUrl, ?string $iosSplashScreenUrl, bool $hideBushelBranding, int $createdAt, int $updatedAt, ?int $deletedAt)
    {
        $this->id = $id;
        $this->flavorId = $flavorId;
        $this->colorPrimary = $colorPrimary;
        $this->colorSecondary = $colorSecondary;
        $this->launcherUrl = $launcherUrl;
        $this->iosAppIconUrl = $iosAppIconUrl;
        $this->logoIdUrl = $logoIdUrl;
        $this->logoStackedUrl = $logoStackedUrl;
        $this->iosSplashScreenUrl = $iosSplashScreenUrl;
        $this->hideBushelBranding = $hideBushelBranding;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
}