<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Model;
        
class DatasourceStandard implements Api\Common\HasTimestamps
{
    public string $id;
    public \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $tenant;
    public ?string $slug = null;
    public ?string $erpType = null;
    public ?string $dataIngestionType = null;
    public ?string $comments = null;
    public int $createdAt;
    public int $updatedAt;
    public ?int $deletedAt = null;

    /**
     * @param  null  $id
     * @param  null  $tenant
     * @param  null  $slug
     * @param  null  $erpType
     * @param  null  $dataIngestionType
     * @param  null  $comments
     * @param  null  $createdAt
     * @param  null  $updatedAt
     * @param  null  $deletedAt
     */
    public function __construct(string $id, \Bushelpowered\Api\Platform\Tenant\V1\Model\TenantStandard $tenant, ?string $slug, ?string $erpType, ?string $dataIngestionType, ?string $comments, int $createdAt, int $updatedAt, ?int $deletedAt)
    {
        $this->id = $id;
        $this->tenant = $tenant;
        $this->slug = $slug;
        $this->erpType = $erpType;
        $this->dataIngestionType = $dataIngestionType;
        $this->comments = $comments;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
        $this->deletedAt = $deletedAt;
    }
    
    public function getCreatedAt(): int
    {
        return $this->createdAt;
    }
    public function getUpdatedAt(): int
    {
        return $this->updatedAt;
    }
    public function getDeletedAt(): ?int
    {
        return $this->deletedAt;
    }
}