<?php
namespace Bushelpowered\Api\Trade\Futures\V1\Request;
        
class UpdateCashBidGroupOverrideRequest 
{
    public string $cashBidGroupOverrideId;
    public string $companyId;
    public string $cqgSymbolId;
    public ?string $commodityName = null;
    public ?string $commodityProductName = null;
    public ?string $tickSize = null;
    public bool $display;
    public bool $ignoreUnitConversion;
    public int $sortOrder;

    /**
     * @param  null  $cashBidGroupOverrideId
     * @param  null  $companyId
     * @param  null  $cqgSymbolId
     * @param  null  $commodityName
     * @param  null  $commodityProductName
     * @param  null  $tickSize
     * @param  null  $display
     * @param  null  $ignoreUnitConversion
     * @param  null  $sortOrder
     */
    public function __construct(string $cashBidGroupOverrideId, string $companyId, string $cqgSymbolId, ?string $commodityName, ?string $commodityProductName, ?string $tickSize, bool $display, bool $ignoreUnitConversion, int $sortOrder)
    {
        $this->cashBidGroupOverrideId = $cashBidGroupOverrideId;
        $this->companyId = $companyId;
        $this->cqgSymbolId = $cqgSymbolId;
        $this->commodityName = $commodityName;
        $this->commodityProductName = $commodityProductName;
        $this->tickSize = $tickSize;
        $this->display = $display;
        $this->ignoreUnitConversion = $ignoreUnitConversion;
        $this->sortOrder = $sortOrder;
    }
    

}